sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=92
left=97
tile=1
tileSpacing=10
caption="WorldClock"
End CompInit
Dim local_group as group
local_group = MakeComponent("group",form1)
CompInit local_group
proto="local_group"
caption="Local time"
look=1
tile=1
tileSpacing=4
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim local_label as label
local_label = MakeComponent("label",local_group)
CompInit local_label
proto="local_label"
caption="xx.xx.xx - xx.xx.xx"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
local_label.name="local_label"
Dim utc_label as label
utc_label = MakeComponent("label",local_group)
CompInit utc_label
proto="utc_label"
caption="UTC/GMT:"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
utc_label.name="utc_label"
local_group.name="local_group"
Dim choice_group as group
choice_group = MakeComponent("group",form1)
CompInit choice_group
proto="choice_group"
caption=""
look=1
tile=1
sizeHControl=3
sizeVControl=3
tileHAlign=3
tileLayout=1
visible=1
End CompInit
Dim geos_choice as choice
geos_choice = MakeComponent("choice",choice_group)
CompInit geos_choice
proto="geos_choice"
caption="GEOS"
sizeHControl=3
sizeVControl=3
look=1
status=1
visible=1
End CompInit
geos_choice.name="geos_choice"
Dim welt_choice as choice
welt_choice = MakeComponent("choice",choice_group)
CompInit welt_choice
proto="welt_choice"
caption="World"
sizeHControl=3
sizeVControl=3
look=1
visible=1
End CompInit
welt_choice.name="welt_choice"
Dim usa_choice as choice
usa_choice = MakeComponent("choice",choice_group)
CompInit usa_choice
proto="usa_choice"
caption="USA"
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
usa_choice.name="usa_choice"
Dim f1_choice as choice
f1_choice = MakeComponent("choice",choice_group)
CompInit f1_choice
proto="f1_choice"
caption="Formula 1"
sizeHControl=3
sizeVControl=3
look=1
visible=1
End CompInit
f1_choice.name="f1_choice"
choice_group.name="choice_group"
Dim time_group as group
time_group = MakeComponent("group",form1)
CompInit time_group
proto="time_group"
caption="Times"
look=1
tile=1
sizeHControl=3
sizeVControl=3
tileHAlign=3
visible=1
End CompInit
Dim t1_label as label
t1_label = MakeComponent("label",time_group)
CompInit t1_label
proto="t1_label"
caption="t1"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t1_label.name="t1_label"
Dim t2_label as label
t2_label = MakeComponent("label",time_group)
CompInit t2_label
proto="t2_label"
caption="t2"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t2_label.name="t2_label"
Dim t3_label as label
t3_label = MakeComponent("label",time_group)
CompInit t3_label
proto="t3_label"
caption="t3"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t3_label.name="t3_label"
Dim t4_label as label
t4_label = MakeComponent("label",time_group)
CompInit t4_label
proto="t4_label"
caption="t4"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t4_label.name="t4_label"
Dim t5_label as label
t5_label = MakeComponent("label",time_group)
CompInit t5_label
proto="t5_label"
caption="t5"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t5_label.name="t5_label"
Dim t6_label as label
t6_label = MakeComponent("label",time_group)
CompInit t6_label
proto="t6_label"
caption="t6"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t6_label.name="t6_label"
Dim t7_label as label
t7_label = MakeComponent("label",time_group)
CompInit t7_label
proto="t7_label"
caption="t7"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t7_label.name="t7_label"
Dim t8_label as label
t8_label = MakeComponent("label",time_group)
CompInit t8_label
proto="t8_label"
caption="t8"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t8_label.name="t8_label"
Dim t9_label as label
t9_label = MakeComponent("label",time_group)
CompInit t9_label
proto="t9_label"
caption="t9"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t9_label.name="t9_label"
time_group.name="time_group"
Dim popup1 as popup
popup1 = MakeComponent("popup",form1)
CompInit popup1
proto="popup1"
caption="Options"
left=0
top=0
visible=1
End CompInit
Dim opt_button as button
opt_button = MakeComponent("button",popup1)
CompInit opt_button
proto="opt_button"
caption="Options..."
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
opt_button.name="opt_button"
popup1.name="popup1"
form1.width=175
form1.height=194
form1.name="form1"
Dim timedate1 as timedate
timedate1 = MakeComponent("timedate","app")
CompInit timedate1
proto="timedate1"
End CompInit
timedate1.name="timedate1"
Dim timer1 as timer
timer1 = MakeComponent("timer","app")
CompInit timer1
proto="timer1"
interval=300
End CompInit
timer1.name="timer1"
Dim opt_dialog as dialog
opt_dialog = MakeComponent("dialog","app")
CompInit opt_dialog
proto="opt_dialog"
left=385
top=159
tile=1
caption="Options..."
tileSpacing=5
End CompInit
Dim group4 as group
group4 = MakeComponent("group",opt_dialog)
CompInit group4
proto="group4"
caption="local time"
look=1
tile=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim diff_number as number
diff_number = MakeComponent("number",group4)
CompInit diff_number
proto="diff_number"
caption="diff from GMT:"
sizeHControl=3
sizeVControl=3
minimum=-12
maximum=12
value=-5
visible=1
End CompInit
diff_number.name="diff_number"
Dim ger_toggle as toggle
ger_toggle = MakeComponent("toggle",group4)
CompInit ger_toggle
proto="ger_toggle"
caption="Germany (MEZ/MESZ)"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
ger_toggle.name="ger_toggle"
group4.name="group4"
Dim group5 as group
group5 = MakeComponent("group",opt_dialog)
CompInit group5
proto="group5"
caption="time format"
look=1
sizeHControl=3
sizeVControl=3
tile=1
tileLayout=1
visible=1
End CompInit
Dim hms_choice as choice
hms_choice = MakeComponent("choice",group5)
CompInit hms_choice
proto="hms_choice"
caption="H:M:S"
sizeHControl=3
sizeVControl=3
look=1
visible=1
End CompInit
hms_choice.name="hms_choice"
Dim hm_choice as choice
hm_choice = MakeComponent("choice",group5)
CompInit hm_choice
proto="hm_choice"
caption="H:M"
sizeHControl=3
sizeVControl=3
status=1
look=1
visible=1
End CompInit
hm_choice.name="hm_choice"
group5.name="group5"
Dim button2 as button
button2 = MakeComponent("button",opt_dialog)
CompInit button2
proto="opt_button"
caption="OK"
sizeHControl=3
sizeVControl=3
closeDialog=1
default=1
cancel=1
visible=1
End CompInit
button2.name="button2"
opt_dialog.height=110
opt_dialog.width=230
opt_dialog.name="opt_dialog"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

	timer1.enabled = 1					' run timer
	timer1_ring(timer1)					' generate _ring Event
	geos_choice_changed(geos_choice)	' generate _changed Event
	opt_dialog.visible = 0
	
	dim ort1 as string					' town - variables
	dim ort2 as string
	dim ort3 as string
	dim ort4 as string
	dim ort5 as string
	dim ort6 as string
	dim ort7 as string
	dim ort8 as string
	dim ort9 as string

	dim diff1 as integer					' time-difference-variables
	dim diff2 as integer
	dim diff3 as integer
	dim diff4 as integer
	dim diff5 as integer
	dim diff6 as integer
	dim diff7 as integer
	dim diff8 as integer
	dim diff9 as integer

	dim tformat as integer ' timeformat
	tformat = 16

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub timer1_ring(self as timer)

' timedate1.Formatx routines using because the WorldClock use
' the settings from preferences

' calculation- and display-routine

	dim aktZeit  as struct TimeOfDay
	dim aktDatum as struct Date
	dim utc as integer
	dim szflag as integer

' get actual time and date

	aktZeit  = timedate1.GetTime()
	aktDatum = timedate1.GetDate()

' set UTC/GMT/worldtime

szflag = SommerzeitCalc()

if ger_toggle.status = 1
		if szflag = 0
			local_group.caption = "Localtime(W)"
			utc = CorrectTime(aktZeit.hour + 23)
		else
			local_group.caption = "Localtime(S)"
			utc = CorrectTime(aktZeit.hour + 22)
		end if
else
	if diff_number.value > 0
		utc = CorrectTime(aktZeit.hour + diff_number.value)
	else
		utc = CorrectTime(aktZeit.hour + 24 - diff_number.value)
	end if
	local_group.caption = "Localtime(Ww)"
end if

' show local- and worldtime

local_label.caption = timedate1.FormatDate(aktDatum, 4) + " - " + timedate1.FormatTime(aktZeit, tformat)
aktZeit.hour = utc ' set time to utc
utc_label.caption = "UTC/GMT:  "+timedate1.FormatTime(aktZeit, tformat)

' show town and there time on nine labels

aktZeit.hour = CorrectTime(utc + diff1)
t1_label.caption = ort1+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff2)
t2_label.caption = ort2+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff3)
t3_label.caption = ort3+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff4)
t4_label.caption = ort4+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff5)
t5_label.caption = ort5+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff6)
t6_label.caption = ort6+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff7)
t7_label.caption = ort7+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff8)
t8_label.caption = ort8+timedate1.FormatTime(aktZeit, tformat)

aktZeit.hour = CorrectTime(utc + diff9)
t9_label.caption = ort9+timedate1.FormatTime(aktZeit, tformat)

end sub

function CorrectTime(stunde as integer) as integer

' correct the time-display, there are no negativ times or
' hours > 24

' example:
' localtime 18:00 (MEZ), Soll: UTC 17:00
' utc = 23; 18 + 23 = 41; 41 - 24 = 17

if stunde > 24 or stunde = 24
	CorrectTime = stunde - 24
else
	CorrectTime = stunde
end if

end function

function SommerzeitCalc() as integer

' calculate the summertime-dates for europe:
' start: last sunday in march 00:00
' end: last saturday in october 2359

dim TageMaerz as integer    ' days in march
dim TageOktober as integer  ' days in october
dim testDatum as struct Date

' get actual date and calculate the days in March and October

testDatum = timedate1.GetDate() 
TageMaerz = timedate1.GetDaysInMonth(testDatum.year, 3)
TageOktober = timedate1.GetDaysInMonth(testDatum.year, 10)

dim EndeMaerz as integer
dim EndeOktober as integer

' get weekday of last day in month

EndeMaerz   = timedate1.GetDayOfWeek(testDatum.year, 3, TageMaerz)
EndeOktober = timedate1.GetDayOfWeek(testDatum.year, 10, TageOktober)

dim SzMaerz as integer    ' summertime - switch-day
dim SzOktober as integer

' calc the last sunday in month (sunday = 0). If the actual day
' another weekday, his value will subtract from the value of
' the last day

' Maerz 1998 = 31 Tage; 31. = Dienstag = 2
' 31 - 2 = 29 -> letzter So: 29. Maerz

SzMaerz   = TageMaerz - EndeMaerz
SzOktober = TageOktober - EndeOktober - 1

' -1 setzt the last sunday to the last saturday

' wintertime: flag = 0
' summertime: flag = 1

if testDatum.month < 4
	if testDatum.day < SzMaerz
		SommerzeitCalc = 0
	else
		SommerzeitCalc = 1
	end if
end if

if testDatum.month > 9
	if testDatum.day > SzOktober
		SommerzeitCalc = 0
	else
		SommerzeitCalc = 1
	end if
end if

end function

sub geos_choice_changed(self as choice)

' diff: if diff positive is diff = timedifference
' if diff negative: diff = 24 - timedifference

if geos_choice.status = 1
	ort1  = "Geoworks, Alameda, USA-CA:  "
	diff1 = 24-8
	
	ort2  = "Breadbox, Port Richey, USA-FL:  "
	diff2 = 24-5
	
	ort3  = "NewDeal, Camebrige, USA-MA:  "
	diff3 = 24-5
	
	ort4  = "NOKIA, Espoo, FINNLAND:  "
	diff4 = 2
	
	ort5  = "Brother, Bridgewater, USA:  "
	diff5 = 24-5
	
	ort6  = "BSW, Berlin, D:  "
	if SommerzeitCalc() = 0
		diff6 = 1
	else
		diff6 = 2
	end if
	
	ort7  = "GOCE, Basel, CH:  "
	if SommerzeitCalc() = 0
		diff7 = 1
	else
		diff7 = 2
	end if
	
	ort8  = "Fuzzi Logic, Washington DC, USA:  "
	diff8 = 24-5
	
	ort9  = "Toshiba, JPA:  "
	diff9 = 9
end if

	timer1_ring(timer1)

end sub

sub welt_choice_changed(self as choice)

' diff: if diff positive is diff = timedifference
' if diff negative: diff = 24 - timedifference

if welt_choice.status = 1
	ort1  = "Berlin, D:  "
	if SommerzeitCalc() = 0
		diff1 = 1
	else
		diff1 = 2
	end if
	
	ort2  = "Moskau, RU:  "
	diff2 = 3
	
	ort3  = "London, GB:  "
	diff3 = 0
	
	ort4  = "Tokio, J:  "
	diff4 = 9
	
	ort5  = "Canberra, AUS:  "
	diff5 = 10
	
	ort6  = "Bagdad, IRAK:  "
	diff6 = 3
	
	ort7  = "Havanna, CUB:  "
	diff7 = 24-4
	
	ort8  = "Mexico, MEX:  "
	diff8 = 24-6
	
	ort9  = "New York, USA:  "
	diff9 = 24-5
end if

	timer1_ring(timer1)

end sub

sub f1_choice_changed(self as choice)

' diff: if diff positive is diff = timedifference
' if diff negative: diff = 24 - timedifference

if f1_choice.status = 1
	ort1  = "Melbourne, Australien:  "
	diff1 = 10
	
	ort2  = "Sao Paulo, Brasilien:  "
	diff2 = 24-3
	
	ort3  = "Buenos Aires, Argentinien:  "
	diff3 = 24-3
	
	ort4  = "Silverstone, England:  "
	diff4 = 0
	
	ort5  = "Suzuka, Japan:  "
	diff5 = 9
	
	ort6  = "Imola; Monza, Italien:  "
	
	ort7  = "Barcelona; Monte Carlo; Hockenheim:  "
	
	ort8  = "Montral, Kanada:  "
	diff8 = 24-5
	
	ort9  = "Zeltweg; Nuerburg; Spa; Budapest:  "
	
	if SommerzeitCalc() = 0
		diff6 = 1
		diff7 = 1
		diff9 = 1
	else
		diff6 = 2
		diff7 = 2
		diff9 = 2
	end if
	
end if

	timer1_ring(timer1)

end sub

sub usa_choice_changed(self as choice)

' diff: if diff positive is diff = timedifference
' if diff negative: diff = 24 - timedifference

if usa_choice.status = 1
	ort1  = "Halifax(CAN):  "
	diff1 = 24-4
	
	ort2  = "New York:  "
	diff2 = 24-5
	
	ort3  = "Washington:  "
	diff3 = 24-5
	
	ort4  = "Chicago:  "
	diff4 = 24-6
	
	ort5  = "Houston:  "
	diff5 = 24-6
	
	ort6  = "Denver:  "
	diff6 = 24-7
	
	ort7  = "San Francisco:  "
	diff7 = 24-8
	
	ort8  = "Juneau:  "
	diff8 = 24-9
	
	ort9  = "Anchorage:  "
	diff9 = 24-10
end if

	timer1_ring(timer1)
	
end sub

sub opt_button_pressed(self as button)
	opt_dialog.visible = 1
end sub

sub ger_toggle_changed(self as toggle)

	if ger_toggle.status = 1
		diff_number.enabled = 0
	else
		diff_number.enabled = 1
	end if

end sub

sub hms_choice_changed(self as choice)

' change timeformat from hh:mm to hh:mm:ss

	if hms_choice.status = 1
		tformat = 15
		timer1.interval = 60
	else
		tformat = 16
		timer1.interval = 300
	end if

	timer1_ring(timer1)

end sub

sub hm_choice_changed(self as choice)

' change timeformat from hh:mm:ss to hh:mm

	if hm_choice.status = 1
		tformat = 16
		timer1.interval = 300
	else
		tformat = 15
		timer1.interval = 60
	end if

	timer1_ring(timer1)

end sub

